﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.UltraChart.Core.Primitives;
using Infragistics.UltraChart.Resources.Appearance;
using Infragistics.UltraChart.Shared.Events;
using Infragistics.UltraChart.Shared.Styles;

namespace LineChartAppearanceSample
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();
		}

		private void Form1_Load(object sender, EventArgs e)
		{
			var rnd = new Random();

			for (int i = 0; i < 12; i++)
			{
				var row = dataSet1.Tables[0].NewRow();
				var values = new List<object>();
				values.Add("Line " + i.ToString());
				for (int j = 0; j < 10; j++)
				{
					values.Add(rnd.Next(50));
				}
				row.ItemArray = values.ToArray();
				dataSet1.Tables[0].Rows.Add(row);
			}

			ultraChart1.ChartType = ChartType.LineChart;
			ultraChart1.Data.DataSource = dataSet1.Tables[0];
			ultraChart1.Data.RowLabelsColumn = 0;
			ultraChart1.Data.UseRowLabelsColumn = true;
			ultraChart1.Legend.Visible = true;

			for (int i = 0; i < dataSet1.Tables[0].Rows.Count; i++)
			{
				var lineApp = new LineAppearance();
				if (i == 8)
				{
					lineApp.LineStyle = new LineStyle(LineCapStyle.Round, LineCapStyle.Round, LineDrawStyle.Dash);
				}
				else
				{
					lineApp.LineStyle = new LineStyle(LineCapStyle.Round, LineCapStyle.Round, LineDrawStyle.Solid);
				}
				ultraChart1.LineChart.LineAppearances.Add(lineApp);
			}
		}

		private void ultraChart1_ChartDrawItem(object sender, ChartDrawItemEventArgs e)
		{
			if ((e.Primitive is Box) && (e.Primitive.Path.Contains("Legend")) && (e.Primitive.Row >= 0))
			{
				var box = e.Primitive as Box;
				var p1 = new Point(box.rect.Left, (box.rect.Top + (box.rect.Height / 2)));
				var p2 = new Point(box.rect.Right, (box.rect.Top + (box.rect.Height / 2)));
				var line = new Line(p1, p2);
				line.PE.Fill = box.PE.Fill;
				line.PE.Stroke = box.PE.Fill;
				line.PE.StrokeWidth = 2;
				line.lineStyle = ultraChart1.LineChart.LineAppearances[e.Primitive.Row].LineStyle;
				e.Primitive = line;
			}
		}
	}
}
